package org.xtext.example.x.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.xtext.example.x.services.XGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalXParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'reference'", "'define'", "';'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_STRING=6;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_SL_COMMENT=8;
    public static final int RULE_INT=5;
    public static final int T__11=11;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalXParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalXParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalXParser.tokenNames; }
    public String getGrammarFileName() { return "InternalX.g"; }


    	private XGrammarAccess grammarAccess;

    	public void setGrammarAccess(XGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleReferences"
    // InternalX.g:53:1: entryRuleReferences : ruleReferences EOF ;
    public final void entryRuleReferences() throws RecognitionException {
        try {
            // InternalX.g:54:1: ( ruleReferences EOF )
            // InternalX.g:55:1: ruleReferences EOF
            {
             before(grammarAccess.getReferencesRule()); 
            pushFollow(FOLLOW_1);
            ruleReferences();

            state._fsp--;

             after(grammarAccess.getReferencesRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleReferences"


    // $ANTLR start "ruleReferences"
    // InternalX.g:62:1: ruleReferences : ( ( rule__References__RefAssignment )* ) ;
    public final void ruleReferences() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:66:2: ( ( ( rule__References__RefAssignment )* ) )
            // InternalX.g:67:2: ( ( rule__References__RefAssignment )* )
            {
            // InternalX.g:67:2: ( ( rule__References__RefAssignment )* )
            // InternalX.g:68:3: ( rule__References__RefAssignment )*
            {
             before(grammarAccess.getReferencesAccess().getRefAssignment()); 
            // InternalX.g:69:3: ( rule__References__RefAssignment )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalX.g:69:4: rule__References__RefAssignment
            	    {
            	    pushFollow(FOLLOW_3);
            	    rule__References__RefAssignment();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

             after(grammarAccess.getReferencesAccess().getRefAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleReferences"


    // $ANTLR start "entryRuleReference"
    // InternalX.g:78:1: entryRuleReference : ruleReference EOF ;
    public final void entryRuleReference() throws RecognitionException {
        try {
            // InternalX.g:79:1: ( ruleReference EOF )
            // InternalX.g:80:1: ruleReference EOF
            {
             before(grammarAccess.getReferenceRule()); 
            pushFollow(FOLLOW_1);
            ruleReference();

            state._fsp--;

             after(grammarAccess.getReferenceRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleReference"


    // $ANTLR start "ruleReference"
    // InternalX.g:87:1: ruleReference : ( ( rule__Reference__Group__0 ) ) ;
    public final void ruleReference() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:91:2: ( ( ( rule__Reference__Group__0 ) ) )
            // InternalX.g:92:2: ( ( rule__Reference__Group__0 ) )
            {
            // InternalX.g:92:2: ( ( rule__Reference__Group__0 ) )
            // InternalX.g:93:3: ( rule__Reference__Group__0 )
            {
             before(grammarAccess.getReferenceAccess().getGroup()); 
            // InternalX.g:94:3: ( rule__Reference__Group__0 )
            // InternalX.g:94:4: rule__Reference__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Reference__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getReferenceAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleReference"


    // $ANTLR start "entryRuleDefinition"
    // InternalX.g:103:1: entryRuleDefinition : ruleDefinition EOF ;
    public final void entryRuleDefinition() throws RecognitionException {
        try {
            // InternalX.g:104:1: ( ruleDefinition EOF )
            // InternalX.g:105:1: ruleDefinition EOF
            {
             before(grammarAccess.getDefinitionRule()); 
            pushFollow(FOLLOW_1);
            ruleDefinition();

            state._fsp--;

             after(grammarAccess.getDefinitionRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleDefinition"


    // $ANTLR start "ruleDefinition"
    // InternalX.g:112:1: ruleDefinition : ( ( rule__Definition__Group__0 ) ) ;
    public final void ruleDefinition() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:116:2: ( ( ( rule__Definition__Group__0 ) ) )
            // InternalX.g:117:2: ( ( rule__Definition__Group__0 ) )
            {
            // InternalX.g:117:2: ( ( rule__Definition__Group__0 ) )
            // InternalX.g:118:3: ( rule__Definition__Group__0 )
            {
             before(grammarAccess.getDefinitionAccess().getGroup()); 
            // InternalX.g:119:3: ( rule__Definition__Group__0 )
            // InternalX.g:119:4: rule__Definition__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Definition__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getDefinitionAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleDefinition"


    // $ANTLR start "rule__Reference__Group__0"
    // InternalX.g:127:1: rule__Reference__Group__0 : rule__Reference__Group__0__Impl rule__Reference__Group__1 ;
    public final void rule__Reference__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:131:1: ( rule__Reference__Group__0__Impl rule__Reference__Group__1 )
            // InternalX.g:132:2: rule__Reference__Group__0__Impl rule__Reference__Group__1
            {
            pushFollow(FOLLOW_4);
            rule__Reference__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Reference__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Reference__Group__0"


    // $ANTLR start "rule__Reference__Group__0__Impl"
    // InternalX.g:139:1: rule__Reference__Group__0__Impl : ( 'reference' ) ;
    public final void rule__Reference__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:143:1: ( ( 'reference' ) )
            // InternalX.g:144:1: ( 'reference' )
            {
            // InternalX.g:144:1: ( 'reference' )
            // InternalX.g:145:2: 'reference'
            {
             before(grammarAccess.getReferenceAccess().getReferenceKeyword_0()); 
            match(input,11,FOLLOW_2); 
             after(grammarAccess.getReferenceAccess().getReferenceKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Reference__Group__0__Impl"


    // $ANTLR start "rule__Reference__Group__1"
    // InternalX.g:154:1: rule__Reference__Group__1 : rule__Reference__Group__1__Impl ;
    public final void rule__Reference__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:158:1: ( rule__Reference__Group__1__Impl )
            // InternalX.g:159:2: rule__Reference__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Reference__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Reference__Group__1"


    // $ANTLR start "rule__Reference__Group__1__Impl"
    // InternalX.g:165:1: rule__Reference__Group__1__Impl : ( ( rule__Reference__NameAssignment_1 ) ) ;
    public final void rule__Reference__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:169:1: ( ( ( rule__Reference__NameAssignment_1 ) ) )
            // InternalX.g:170:1: ( ( rule__Reference__NameAssignment_1 ) )
            {
            // InternalX.g:170:1: ( ( rule__Reference__NameAssignment_1 ) )
            // InternalX.g:171:2: ( rule__Reference__NameAssignment_1 )
            {
             before(grammarAccess.getReferenceAccess().getNameAssignment_1()); 
            // InternalX.g:172:2: ( rule__Reference__NameAssignment_1 )
            // InternalX.g:172:3: rule__Reference__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Reference__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getReferenceAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Reference__Group__1__Impl"


    // $ANTLR start "rule__Definition__Group__0"
    // InternalX.g:181:1: rule__Definition__Group__0 : rule__Definition__Group__0__Impl rule__Definition__Group__1 ;
    public final void rule__Definition__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:185:1: ( rule__Definition__Group__0__Impl rule__Definition__Group__1 )
            // InternalX.g:186:2: rule__Definition__Group__0__Impl rule__Definition__Group__1
            {
            pushFollow(FOLLOW_4);
            rule__Definition__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Definition__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Definition__Group__0"


    // $ANTLR start "rule__Definition__Group__0__Impl"
    // InternalX.g:193:1: rule__Definition__Group__0__Impl : ( 'define' ) ;
    public final void rule__Definition__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:197:1: ( ( 'define' ) )
            // InternalX.g:198:1: ( 'define' )
            {
            // InternalX.g:198:1: ( 'define' )
            // InternalX.g:199:2: 'define'
            {
             before(grammarAccess.getDefinitionAccess().getDefineKeyword_0()); 
            match(input,12,FOLLOW_2); 
             after(grammarAccess.getDefinitionAccess().getDefineKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Definition__Group__0__Impl"


    // $ANTLR start "rule__Definition__Group__1"
    // InternalX.g:208:1: rule__Definition__Group__1 : rule__Definition__Group__1__Impl rule__Definition__Group__2 ;
    public final void rule__Definition__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:212:1: ( rule__Definition__Group__1__Impl rule__Definition__Group__2 )
            // InternalX.g:213:2: rule__Definition__Group__1__Impl rule__Definition__Group__2
            {
            pushFollow(FOLLOW_5);
            rule__Definition__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Definition__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Definition__Group__1"


    // $ANTLR start "rule__Definition__Group__1__Impl"
    // InternalX.g:220:1: rule__Definition__Group__1__Impl : ( RULE_ID ) ;
    public final void rule__Definition__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:224:1: ( ( RULE_ID ) )
            // InternalX.g:225:1: ( RULE_ID )
            {
            // InternalX.g:225:1: ( RULE_ID )
            // InternalX.g:226:2: RULE_ID
            {
             before(grammarAccess.getDefinitionAccess().getIDTerminalRuleCall_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getDefinitionAccess().getIDTerminalRuleCall_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Definition__Group__1__Impl"


    // $ANTLR start "rule__Definition__Group__2"
    // InternalX.g:235:1: rule__Definition__Group__2 : rule__Definition__Group__2__Impl ;
    public final void rule__Definition__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:239:1: ( rule__Definition__Group__2__Impl )
            // InternalX.g:240:2: rule__Definition__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Definition__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Definition__Group__2"


    // $ANTLR start "rule__Definition__Group__2__Impl"
    // InternalX.g:246:1: rule__Definition__Group__2__Impl : ( ';' ) ;
    public final void rule__Definition__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:250:1: ( ( ';' ) )
            // InternalX.g:251:1: ( ';' )
            {
            // InternalX.g:251:1: ( ';' )
            // InternalX.g:252:2: ';'
            {
             before(grammarAccess.getDefinitionAccess().getSemicolonKeyword_2()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getDefinitionAccess().getSemicolonKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Definition__Group__2__Impl"


    // $ANTLR start "rule__References__RefAssignment"
    // InternalX.g:262:1: rule__References__RefAssignment : ( ruleReference ) ;
    public final void rule__References__RefAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:266:1: ( ( ruleReference ) )
            // InternalX.g:267:2: ( ruleReference )
            {
            // InternalX.g:267:2: ( ruleReference )
            // InternalX.g:268:3: ruleReference
            {
             before(grammarAccess.getReferencesAccess().getRefReferenceParserRuleCall_0()); 
            pushFollow(FOLLOW_2);
            ruleReference();

            state._fsp--;

             after(grammarAccess.getReferencesAccess().getRefReferenceParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__References__RefAssignment"


    // $ANTLR start "rule__Reference__NameAssignment_1"
    // InternalX.g:277:1: rule__Reference__NameAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__Reference__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalX.g:281:1: ( ( ( RULE_ID ) ) )
            // InternalX.g:282:2: ( ( RULE_ID ) )
            {
            // InternalX.g:282:2: ( ( RULE_ID ) )
            // InternalX.g:283:3: ( RULE_ID )
            {
             before(grammarAccess.getReferenceAccess().getNameDefinitionsCrossReference_1_0()); 
            // InternalX.g:284:3: ( RULE_ID )
            // InternalX.g:285:4: RULE_ID
            {
             before(grammarAccess.getReferenceAccess().getNameDefinitionsIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getReferenceAccess().getNameDefinitionsIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getReferenceAccess().getNameDefinitionsCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Reference__NameAssignment_1"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000002000L});

}