package org.xtext.example.x.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.xtext.example.x.services.XGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalXParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'reference'", "'define'", "';'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_STRING=6;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_SL_COMMENT=8;
    public static final int RULE_INT=5;
    public static final int T__11=11;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalXParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalXParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalXParser.tokenNames; }
    public String getGrammarFileName() { return "InternalX.g"; }



     	private XGrammarAccess grammarAccess;

        public InternalXParser(TokenStream input, XGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "References";
       	}

       	@Override
       	protected XGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleReferences"
    // InternalX.g:64:1: entryRuleReferences returns [EObject current=null] : iv_ruleReferences= ruleReferences EOF ;
    public final EObject entryRuleReferences() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleReferences = null;


        try {
            // InternalX.g:64:51: (iv_ruleReferences= ruleReferences EOF )
            // InternalX.g:65:2: iv_ruleReferences= ruleReferences EOF
            {
             newCompositeNode(grammarAccess.getReferencesRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleReferences=ruleReferences();

            state._fsp--;

             current =iv_ruleReferences; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleReferences"


    // $ANTLR start "ruleReferences"
    // InternalX.g:71:1: ruleReferences returns [EObject current=null] : ( (lv_ref_0_0= ruleReference ) )* ;
    public final EObject ruleReferences() throws RecognitionException {
        EObject current = null;

        EObject lv_ref_0_0 = null;



        	enterRule();

        try {
            // InternalX.g:77:2: ( ( (lv_ref_0_0= ruleReference ) )* )
            // InternalX.g:78:2: ( (lv_ref_0_0= ruleReference ) )*
            {
            // InternalX.g:78:2: ( (lv_ref_0_0= ruleReference ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalX.g:79:3: (lv_ref_0_0= ruleReference )
            	    {
            	    // InternalX.g:79:3: (lv_ref_0_0= ruleReference )
            	    // InternalX.g:80:4: lv_ref_0_0= ruleReference
            	    {

            	    				newCompositeNode(grammarAccess.getReferencesAccess().getRefReferenceParserRuleCall_0());
            	    			
            	    pushFollow(FOLLOW_3);
            	    lv_ref_0_0=ruleReference();

            	    state._fsp--;


            	    				if (current==null) {
            	    					current = createModelElementForParent(grammarAccess.getReferencesRule());
            	    				}
            	    				add(
            	    					current,
            	    					"ref",
            	    					lv_ref_0_0,
            	    					"org.xtext.example.x.X.Reference");
            	    				afterParserOrEnumRuleCall();
            	    			

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleReferences"


    // $ANTLR start "entryRuleReference"
    // InternalX.g:100:1: entryRuleReference returns [EObject current=null] : iv_ruleReference= ruleReference EOF ;
    public final EObject entryRuleReference() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleReference = null;


        try {
            // InternalX.g:100:50: (iv_ruleReference= ruleReference EOF )
            // InternalX.g:101:2: iv_ruleReference= ruleReference EOF
            {
             newCompositeNode(grammarAccess.getReferenceRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleReference=ruleReference();

            state._fsp--;

             current =iv_ruleReference; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleReference"


    // $ANTLR start "ruleReference"
    // InternalX.g:107:1: ruleReference returns [EObject current=null] : (otherlv_0= 'reference' ( (otherlv_1= RULE_ID ) ) ) ;
    public final EObject ruleReference() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;


        	enterRule();

        try {
            // InternalX.g:113:2: ( (otherlv_0= 'reference' ( (otherlv_1= RULE_ID ) ) ) )
            // InternalX.g:114:2: (otherlv_0= 'reference' ( (otherlv_1= RULE_ID ) ) )
            {
            // InternalX.g:114:2: (otherlv_0= 'reference' ( (otherlv_1= RULE_ID ) ) )
            // InternalX.g:115:3: otherlv_0= 'reference' ( (otherlv_1= RULE_ID ) )
            {
            otherlv_0=(Token)match(input,11,FOLLOW_4); 

            			newLeafNode(otherlv_0, grammarAccess.getReferenceAccess().getReferenceKeyword_0());
            		
            // InternalX.g:119:3: ( (otherlv_1= RULE_ID ) )
            // InternalX.g:120:4: (otherlv_1= RULE_ID )
            {
            // InternalX.g:120:4: (otherlv_1= RULE_ID )
            // InternalX.g:121:5: otherlv_1= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getReferenceRule());
            					}
            				
            otherlv_1=(Token)match(input,RULE_ID,FOLLOW_2); 

            					newLeafNode(otherlv_1, grammarAccess.getReferenceAccess().getNameDefinitionsCrossReference_1_0());
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleReference"


    // $ANTLR start "entryRuleDefinition"
    // InternalX.g:136:1: entryRuleDefinition returns [String current=null] : iv_ruleDefinition= ruleDefinition EOF ;
    public final String entryRuleDefinition() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleDefinition = null;


        try {
            // InternalX.g:136:50: (iv_ruleDefinition= ruleDefinition EOF )
            // InternalX.g:137:2: iv_ruleDefinition= ruleDefinition EOF
            {
             newCompositeNode(grammarAccess.getDefinitionRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDefinition=ruleDefinition();

            state._fsp--;

             current =iv_ruleDefinition.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDefinition"


    // $ANTLR start "ruleDefinition"
    // InternalX.g:143:1: ruleDefinition returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (kw= 'define' this_ID_1= RULE_ID kw= ';' ) ;
    public final AntlrDatatypeRuleToken ruleDefinition() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        Token this_ID_1=null;


        	enterRule();

        try {
            // InternalX.g:149:2: ( (kw= 'define' this_ID_1= RULE_ID kw= ';' ) )
            // InternalX.g:150:2: (kw= 'define' this_ID_1= RULE_ID kw= ';' )
            {
            // InternalX.g:150:2: (kw= 'define' this_ID_1= RULE_ID kw= ';' )
            // InternalX.g:151:3: kw= 'define' this_ID_1= RULE_ID kw= ';'
            {
            kw=(Token)match(input,12,FOLLOW_4); 

            			current.merge(kw);
            			newLeafNode(kw, grammarAccess.getDefinitionAccess().getDefineKeyword_0());
            		
            this_ID_1=(Token)match(input,RULE_ID,FOLLOW_5); 

            			current.merge(this_ID_1);
            		

            			newLeafNode(this_ID_1, grammarAccess.getDefinitionAccess().getIDTerminalRuleCall_1());
            		
            kw=(Token)match(input,13,FOLLOW_2); 

            			current.merge(kw);
            			newLeafNode(kw, grammarAccess.getDefinitionAccess().getSemicolonKeyword_2());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDefinition"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000002000L});

}