package org.xtext.example.y.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.xtext.example.y.services.YGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalYParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'define'", "';'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_STRING=6;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_SL_COMMENT=8;
    public static final int RULE_INT=5;
    public static final int T__11=11;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__12=12;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalYParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalYParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalYParser.tokenNames; }
    public String getGrammarFileName() { return "InternalY.g"; }



     	private YGrammarAccess grammarAccess;

        public InternalYParser(TokenStream input, YGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "Definitions";
       	}

       	@Override
       	protected YGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleDefinitions"
    // InternalY.g:64:1: entryRuleDefinitions returns [EObject current=null] : iv_ruleDefinitions= ruleDefinitions EOF ;
    public final EObject entryRuleDefinitions() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDefinitions = null;


        try {
            // InternalY.g:64:52: (iv_ruleDefinitions= ruleDefinitions EOF )
            // InternalY.g:65:2: iv_ruleDefinitions= ruleDefinitions EOF
            {
             newCompositeNode(grammarAccess.getDefinitionsRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDefinitions=ruleDefinitions();

            state._fsp--;

             current =iv_ruleDefinitions; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDefinitions"


    // $ANTLR start "ruleDefinitions"
    // InternalY.g:71:1: ruleDefinitions returns [EObject current=null] : ( (lv_defs_0_0= ruleDefinition ) ) ;
    public final EObject ruleDefinitions() throws RecognitionException {
        EObject current = null;

        AntlrDatatypeRuleToken lv_defs_0_0 = null;



        	enterRule();

        try {
            // InternalY.g:77:2: ( ( (lv_defs_0_0= ruleDefinition ) ) )
            // InternalY.g:78:2: ( (lv_defs_0_0= ruleDefinition ) )
            {
            // InternalY.g:78:2: ( (lv_defs_0_0= ruleDefinition ) )
            // InternalY.g:79:3: (lv_defs_0_0= ruleDefinition )
            {
            // InternalY.g:79:3: (lv_defs_0_0= ruleDefinition )
            // InternalY.g:80:4: lv_defs_0_0= ruleDefinition
            {

            				newCompositeNode(grammarAccess.getDefinitionsAccess().getDefsDefinitionParserRuleCall_0());
            			
            pushFollow(FOLLOW_2);
            lv_defs_0_0=ruleDefinition();

            state._fsp--;


            				if (current==null) {
            					current = createModelElementForParent(grammarAccess.getDefinitionsRule());
            				}
            				add(
            					current,
            					"defs",
            					lv_defs_0_0,
            					"org.xtext.example.y.Y.Definition");
            				afterParserOrEnumRuleCall();
            			

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDefinitions"


    // $ANTLR start "entryRuleDefinition"
    // InternalY.g:100:1: entryRuleDefinition returns [String current=null] : iv_ruleDefinition= ruleDefinition EOF ;
    public final String entryRuleDefinition() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleDefinition = null;


        try {
            // InternalY.g:100:50: (iv_ruleDefinition= ruleDefinition EOF )
            // InternalY.g:101:2: iv_ruleDefinition= ruleDefinition EOF
            {
             newCompositeNode(grammarAccess.getDefinitionRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDefinition=ruleDefinition();

            state._fsp--;

             current =iv_ruleDefinition.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDefinition"


    // $ANTLR start "ruleDefinition"
    // InternalY.g:107:1: ruleDefinition returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (kw= 'define' this_ID_1= RULE_ID kw= ';' ) ;
    public final AntlrDatatypeRuleToken ruleDefinition() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        Token this_ID_1=null;


        	enterRule();

        try {
            // InternalY.g:113:2: ( (kw= 'define' this_ID_1= RULE_ID kw= ';' ) )
            // InternalY.g:114:2: (kw= 'define' this_ID_1= RULE_ID kw= ';' )
            {
            // InternalY.g:114:2: (kw= 'define' this_ID_1= RULE_ID kw= ';' )
            // InternalY.g:115:3: kw= 'define' this_ID_1= RULE_ID kw= ';'
            {
            kw=(Token)match(input,11,FOLLOW_3); 

            			current.merge(kw);
            			newLeafNode(kw, grammarAccess.getDefinitionAccess().getDefineKeyword_0());
            		
            this_ID_1=(Token)match(input,RULE_ID,FOLLOW_4); 

            			current.merge(this_ID_1);
            		

            			newLeafNode(this_ID_1, grammarAccess.getDefinitionAccess().getIDTerminalRuleCall_1());
            		
            kw=(Token)match(input,12,FOLLOW_2); 

            			current.merge(kw);
            			newLeafNode(kw, grammarAccess.getDefinitionAccess().getSemicolonKeyword_2());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDefinition"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000001000L});

}